
function detection(horses, gray_im, edge_image, scale_array, im_name, res_folder)
% detect a running horse.
% horses, the template database;
% gray_im, orginal gray image;
% edge_image, the sampled edge image;
% scale_array, scales used to resize the template;
% 
% author: {xiang.bai, wxghust}@gmail.com


tic
   
    [rows, cols] = size(edge_image);
    edge_image = bwmorph(edge_image, 'thin', Inf);
    
	%-------------- calculate direction map----------------
    [els, edge_image] = edgelink(edge_image, 3);
	
	% dir_edgepoint = im_dir( edge_image, els );
	dir_edgepoint = [];
	
    % edge_image = ones(size(edge_image));
    % edge_image(find(isnan(dir_edgepoint))) = 0;
        
	%-------------- distance transform ----------------------
	[distmap, label] = bwdist(edge_image);
    
    %--------------- calc shape context feather -------------
    % sc_map = im_sc(edge_image);
	sc_map = [];

	% ---------------- sample image ---------------
	sample_dist = 10;
	zero_response = 2;

	%%right_tplt = zeros(6, 2);
	
	row_sample = 1 : sample_dist : rows;
	col_sample = 1 : sample_dist : cols;

	response_map = zeros( length(row_sample)*length(col_sample), 3 );	% col 1: row; col 2: col; col 3: response
	response_map_index = 0;
	for row = row_sample
		for col = col_sample
			[response_map, response_map_index] = POINT_RESPONSE_2(row, col, rows, cols, horses, scale_array, distmap, label, dir_edgepoint, sc_map, zero_response, response_map, response_map_index);
		end
    end

    [local_max_rows, local_max_cols] = find_local_maximal(response_map, rows, cols);

	ang_arr{1} = [0, -5, 5, 10, -10, 15, -15, 20, -20] * pi / 180;
	ang_arr{2} = [0, -5, 5] * pi / 180;
	ang_arr{3} = [0, -5, 5] * pi / 180;
	ang_arr{4} = [0, -5, 5] * pi / 180;
	ang_arr{5} = [0, -5, 5,] * pi / 180;	
	ang_arr{6} = [0] * pi / 180;
        
	if ~isempty(local_max_rows)
        results(length(local_max_rows)) = struct( 'resp', [], 'tplt', [], 'ref', [], 'skel', [], ...
												'cntr', [], 'col', [], 'row', []);
	else
		results = [];
	end
	
    for k = 1:length(local_max_rows)
        row0 = local_max_rows(k)-6 :3 :local_max_rows(k)+6 ;
        col0 = local_max_cols(k)-6:3:local_max_cols(k)+6;
	
		min_resp=[]; min_tplt=[]; min_skel=[]; min_ref=[]; min_cntr=[]; min_col=0; min_row=0;
        for row = row0
            for col = col0
                [min_resp, min_tplt, min_ref, min_skel, min_cntr, min_row, min_col] = POINT_RESPONSE_3(row, col, rows, cols, horses, scale_array, ang_arr, distmap, label, dir_edgepoint, sc_map, zero_response, ...
                                                                                min_resp, min_tplt, min_ref, min_skel, min_cntr, min_row, min_col);	
            end
        end
		results(k).resp = min_resp;
		results(k).tplt = min_tplt;
		results(k).ref  = min_ref;
		results(k).skel = min_skel;
		results(k).cntr = min_cntr;
		results(k).row  = min_row;
		results(k).col  = min_col;		
    end
    save( [res_folder, im_name(1:end-4)] , 'results', 'edge_image' );
toc
    
	
		